*******************************************************************************
*  PROGRAM:      dbfile.prg
*
*  WRITTEN BY:   Borland Samples Group.
*
*  DATE:         1/94
*
*  UPDATED:      3/94
*
*  VERSION:      Field Test March 94
*
*  DESCRIPTION:  Part of the dbfile example. 
*                See the file dbfile.cpp for a complete description.
*                The dbgrep.prg and dbsysdrv.prg programs show how the
*                dbfile system can be used.
*
*  PARAMETERS:   None
*
*  CALLS:        To dbfile.dll
*
*  USAGE:        This program is not meant to be run stand alone, but by
*                adding the following 2 lines in a program you get full
*                access to the textfile class:
*
*                SET PROC to dbfile ADDITIVE
*                DO dbfile
*
*******************************************************************************

* Be quiet.
SET talk off

*
*  Definition of the textfile class.  Usage of this class requires
*  dbfile.dll to be on your search path.
*

* TFinit is called once to set up the class.
EXTERN CLONG TFinit()                          dbfile.dll

* These are  the functions that are available.
EXTERN CLOGICAL TFclose()                      dbfile.dll
EXTERN CLOGICAL TFeof()                        dbfile.dll
EXTERN CLOGICAL TFerror()                      dbfile.dll
EXTERN CLOGICAL TFfieldseparator( CSTRING )    dbfile.dll
EXTERN CLOGICAL TFfilter( CSTRING )            dbfile.dll
EXTERN CSTRING  TFgeterror()                   dbfile.dll
EXTERN CSTRING  TFgetfield( CWORD )            dbfile.dll
EXTERN CSTRING  TFgetline()                    dbfile.dll
EXTERN CLOGICAL TFlineseparator( CSTRING )     dbfile.dll
EXTERN CLOGICAL TFopen( CSTRING )              dbfile.dll
EXTERN CVOID    TFrelease()                    dbfile.dll
EXTERN CWORD    TFgetrec()                     dbfile.dll
   
CLASS textfile

   * Call the DLL to set up all the details.
   this.mystruct       = TFinit()

   * Initialize the memberfunctions.
   this.close          = TFclose
   this.eof            = TFeof
   this.error          = TFerror
   this.fieldseparator = TFfieldseparator
   this.filter         = TFfilter
   this.geterror       = TFgeterror
   this.getfield       = TFgetfield
   this.getline        = TFgetline
   this.lineseparator  = TFlineseparator
   this.open           = TFopen
   this.release        = TFrelease
   this.getrec         = TFgetrec

ENDCLASS
